package jp.hishidama.robot.ie;

import java.util.List;

import jp.hishidama.robot.win.FileSaveDialog;
import jp.hishidama.win32.JWnd;

/**
 * IEt@C_E[h_CAO.
 * <p>
 * IEŃt@C_E[hۂ́AŏIIɃt@C_E[hs_CAOB
 * </p>
 * 
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/soft/java/ierobot.html">Ђ</a>
 * @see FileDownloadDialogFactory#enumFileDownloadDialog()
 * @see FileDownloadRobot#download(int, String, int)
 * @since 2007.11.01
 */
public class FileDownloadProgressDialog extends FileDownloadDialog {

	protected FileDownloadConfirmDialog confirmDlg;

	protected FileSaveDialog saveDlg;

	protected JWnd close, file, folder, cancel;

	/**
	 * RXgN^[.
	 * 
	 * @param wnd
	 *            ut@C_̃E[hv_CAÕEBhEnh
	 * @see FileDownloadDialogFactory#enumFileDownloadDialog()
	 */
	public FileDownloadProgressDialog(JWnd wnd) {
		super(wnd);
	}

	/**
	 * J/ۑmF_CAO擾.
	 * 
	 * @return J/ۑmF_CAOi݂ȂꍇAnullj
	 */
	public FileDownloadConfirmDialog getConfirmDialog() {
		if (confirmDlg != null) {
			if (!confirmDlg.getWnd().isWindow()) {
				return null;
			}
			return confirmDlg;
		}

		List list = JWnd.enumWindows();
		for (int i = 0; i < list.size(); i++) {
			JWnd w = (JWnd) list.get(i);
			if (!wnd.equals(w.GetParent())) {
				continue;
			}
			if (isConfirmDlg(w)) {
				confirmDlg = createConfirmDlg(w);
				break;
			}
		}
		return confirmDlg;
	}

	/**
	 * J/ۑmF_CAOf.
	 * <p>
	 * IẼo[WςƂ͓\bhI[o[ChĔ@ύXzB
	 * </p>
	 * 
	 * @param w
	 *            EBhEnh
	 * @return J/ۑmF_CAȌꍇAtrue
	 */
	protected boolean isConfirmDlg(JWnd w) {
		String title = w.GetWindowText();
		return "t@C̃_E[h".equals(title);
	}

	protected FileDownloadConfirmDialog createConfirmDlg(JWnd w) {
		return new FileDownloadConfirmDialog(w);
	}

	/**
	 * ۑ_CAO擾.
	 * 
	 * @return ۑ_CAOi݂ȂꍇAnullj
	 */
	public FileSaveDialog getSaveDialog() {
		if (saveDlg != null) {
			if (!saveDlg.getWnd().isWindow()) {
				return null;
			}
			return saveDlg;
		}

		List list = JWnd.enumWindows();
		for (int i = 0; i < list.size(); i++) {
			JWnd w = (JWnd) list.get(i);
			if (!wnd.equals(w.GetParent())) {
				continue;
			}
			if (isSaveDlg(w)) {
				saveDlg = createSaveDlg(w);
				break;
			}
		}
		return saveDlg;
	}

	protected boolean isSaveDlg(JWnd w) {
		String title = w.GetWindowText();
		return "Otĕۑ".equals(title);
	}

	protected FileSaveDialog createSaveDlg(JWnd w) {
		return new FileSaveDialog(w);
	}

	protected void doInit(InitData ini) {
		// if (ini.i == 0)
		// listID();

		if (initInfo(ini)) {
			return;
		}
		if (initCloseButton(ini)) {
			return;
		}
		if (initFileButton(ini)) {
			return;
		}
		if (initFolderButton(ini)) {
			return;
		}
		if (initCanelButton(ini)) {
			return;
		}
	}

	protected boolean initInfo(InitData ini) {
		if (!"msctls_progress32".equals(ini.name)) {
			return false;
		}
		JWnd w = (JWnd) ini.list.get(ini.i - 1);
		String info = w.GetWindowText();
		int f = info.indexOf(" - ");
		String src, name;
		if (f >= 0) {
			src = info.substring(0, f);
			name = info.substring(f + 3);
		} else {
			src = null;
			name = info;
		}
		setSrc(src);
		setName(name);
		return true;
	}

	protected boolean initCloseButton(InitData ini) {
		if (ini.isButton() && ini.textStartsWith("_E[h̊Ã_CAO {bNX")) {
			setCloseButton(ini.wnd);
			return true;
		}
		return false;
	}

	protected boolean initFileButton(InitData ini) {
		if (ini.isButton() && ini.textStartsWith("t@CJ")) {
			setFileButton(ini.wnd);
			return true;
		}
		return false;
	}

	protected boolean initFolderButton(InitData ini) {
		if (ini.isButton() && ini.textStartsWith("tH_J")) {
			setFolderButton(ini.wnd);
			return true;
		}
		return false;
	}

	protected boolean initCanelButton(InitData ini) {
		if (ini.isButton() && ini.isDlgCtrl(IDCANCEL)) {
			setCancelButton(ini.wnd);
			return true;
		}
		return false;
	}

	protected void setCloseButton(JWnd btn) {
		this.close = btn;
	}

	protected void setFileButton(JWnd btn) {
		this.file = btn;
	}

	protected void setFolderButton(JWnd btn) {
		this.folder = btn;
	}

	protected void setCancelButton(JWnd btn) {
		this.cancel = btn;
	}

	/**
	 * u_E[hɃ_CAOv`FbN擾.
	 * 
	 * @return _E[hɃ_CAO`FbNtĂꍇAtrue
	 */
	public boolean isCloseDownloaded() {
		init();
		try {
			return wnd.IsDlgButtonChecked(this.close.GetDlgCtrlID()) != BST_UNCHECKED;
		} catch (RuntimeException e) {
			return false;
		}
	}

	/**
	 * u_E[hɃ_CAOv`FbNݒ.
	 * 
	 * @param b
	 *            _E[hɃ_CAOꍇAtrue
	 * @return ꍇAtrue
	 */
	public boolean setCloseDownloaded(boolean b) {
		init();
		try {
			int c = b ? BST_CHECKED : BST_UNCHECKED;
			return wnd.CheckDlgButton(close.GetDlgCtrlID(), c);
		} catch (RuntimeException e) {
			return false;
		}
	}

	/**
	 * ut@CJv{^Lf.
	 * 
	 * @return LȏꍇAtrue
	 */
	public boolean isFileButtonEnabled() {
		init();
		try {
			return file.IsWindowEnabled();
		} catch (RuntimeException e) {
			return false;
		}
	}

	/**
	 * ut@CJv{^NbN.
	 * <p>
	 * OɃ_CAOɃtH[JX𓖂ĂĂƁB
	 * </p>
	 * 
	 * @return ꍇAtrue
	 */
	public boolean clickFileButton() {
		init();
		return click(file);
	}

	/**
	 * utH_Jv{^Lf.
	 * 
	 * @return LȏꍇAtrue
	 */
	public boolean isFolderButtonEnabled() {
		init();
		try {
			return folder.IsWindowEnabled();
		} catch (RuntimeException e) {
			return false;
		}
	}

	/**
	 * utH_Jv{^NbN.
	 * <p>
	 * OɃ_CAOɃtH[JX𓖂ĂĂƁB
	 * </p>
	 * 
	 * @return ꍇAtrue
	 */
	public boolean clickFolderButton() {
		init();
		return click(folder);
	}

	/**
	 * uLZv{^NbN.
	 * <p>
	 * ꍇɂẮuv{^AuLZv{^ƓB
	 * </p>
	 * 
	 * @return ꍇAtrue
	 */
	public boolean clickCancelButton() {
		init();
		return click(cancel);
	}

}
